;=========================================================
;DirectDraw structures/values (many thanks to FASM example files)
;=========================================================

interface DirectDraw,\
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Compact,\
	    CreateClipper,\
	    CreatePalette,\
	    CreateSurface,\
	    DuplicateSurface,\
	    EnumDisplayModes,\
	    EnumSurfaces,\
	    FlipToGDISurface,\
	    GetCaps,\
	    GetDisplayMode,\
	    GetFourCCCodes,\
	    GetGDISurface,\
	    GetMonitorFrequency,\
	    GetScanLine,\
	    GetVerticalBlankStatus,\
	    Initialize,\
	    RestoreDisplayMode,\
	    SetCooperativeLevel,\
	    SetDisplayMode,\
	    WaitForVerticalBlank,\
	    GetAvailableVidMem,\
	    GetSurfaceFromDC,\
	    RestoreAllSurfaces,\
	    TestCooperativeLevel,\
	    GetDeviceIdentifier,\
	    StartModeTest,\
	    EvaluateMode

interface DirectDrawSurface,\
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    AddAttachedSurface,\
	    AddOverlayDirtyRect,\
	    Blt,\
	    BltBatch,\
	    BltFast,\
	    DeleteAttachedSurface,\
	    EnumAttachedSurfaces,\
	    EnumOverlayZOrders,\
	    Flip,\
	    GetAttachedSurface,\
	    GetBltStatus,\
	    GetCaps,\
	    GetClipper,\
	    GetColorKey,\
	    GetDC,\
	    GetFlipStatus,\
	    GetOverlayPosition,\
	    GetPalette,\
	    GetPixelFormat,\
	    GetSurfaceDesc,\
	    Initialize,\
	    IsLost,\
	    Lock,\
	    ReleaseDC,\
	    Restore,\
	    SetClipper,\
	    SetColorKey,\
	    SetOverlayPosition,\
	    SetPalette,\
	    Unlock,\
	    UpdateOverlay,\
	    UpdateOverlayDisplay,\
	    UpdateOverlayZOrder,\
	    GetDDInterface,\
	    PageLock,\
	    PageUnlock,\
	    SetSurfaceDesc,\
	    SetPrivateData,\
	    GetPrivateData,\
	    FreePrivateData,\
	    GetUniquenessValue,\
	    ChangeUniquenessValue,\
	    SetPriority,\
	    GetPriority,\
	    SetLOD,\
	    GetLOD

DDLOCK_SURFACEMEMORYPTR   =	000000000h
DDLOCK_WAIT		  =	000000001h
DDLOCK_EVENT		  =	000000002h
DDLOCK_READONLY 	  =	000000010h
DDLOCK_WRITEONLY	  =	000000020h
DDLOCK_NOSYSLOCK	  =	000000800h

DDERR_WASSTILLDRAWING		  =	088760000h+540
DDERR_SURFACELOST		  =	088760000h+450

struct DDCOLORKEY
  .dwColorSpaceLowValue  dd ?
  .dwColorSpaceHighValue dd ?
ends

struct DDPIXELFORMAT
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwFourCC	   dd ?
  label .dwYUVBitCount	   dword
  label .dwZBufferBitDepth dword
  label .dwAlphaBitDepth   dword
	.dwRGBBitCount	   dd ?
  label .dwYBitMask	   dword
	.dwRBitMask	   dd ?
  label .dwUBitMask	   dword
	.dwGBitMask	   dd ?
  label .dwVBitMask	   dword
	.dwBBitMask	   dd ?
  label .dwYUVAlphaBitMask dword
  label .dwRGBZBitMask	   dword
  label .dwYUVZBitMask	   dword
	.dwRGBAlphaBitMask dd ?
ends

struct DDSCAPS2
  .dwCaps  dd ?
  .dwCaps2 dd ?
  .dwCaps3 dd ?
  .dwCaps4 dd ?
ends

struct DDSURFACEDESC2
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwHeight	   dd ?
	.dwWidth	   dd ?
  label .dwLinearSize	   dword
	.lPitch 	   dd ?
	.dwBackBufferCount dd ?
  label .dwZBufferBitDepth dword
  label .dwRefreshRate	   dword
	.dwMipMapCount	   dd ?
	.dwAlphaBitDepth   dd ?
	.dwReserved	   dd ?
	.lpSurface	   dd ?
	.ddckCKDestOverlay DDCOLORKEY
	.ddckCKDestBlt	   DDCOLORKEY
	.ddckCKSrcOverlay  DDCOLORKEY
	.ddckCKSrcBlt	   DDCOLORKEY
	.ddpfPixelFormat   DDPIXELFORMAT
	.ddsCaps	   DDSCAPS2
	.dwTextureStage    dd ?
ends

DDBLT_ALPHADEST 		 =     000000001h
DDBLT_ALPHADESTCONSTOVERRIDE	 =     000000002h
DDBLT_ALPHADESTNEG		 =     000000004h
DDBLT_ALPHADESTSURFACEOVERRIDE	 =     000000008h
DDBLT_ALPHAEDGEBLEND		 =     000000010h
DDBLT_ALPHASRC			 =     000000020h
DDBLT_ALPHASRCCONSTOVERRIDE	 =     000000040h
DDBLT_ALPHASRCNEG		 =     000000080h
DDBLT_ALPHASRCSURFACEOVERRIDE	 =     000000100h
DDBLT_ASYNC			 =     000000200h
DDBLT_COLORFILL 		 =     000000400h
DDBLT_DDFX			 =     000000800h
DDBLT_DDROPS			 =     000001000h
DDBLT_KEYDEST			 =     000002000h
DDBLT_KEYDESTOVERRIDE		 =     000004000h
DDBLT_KEYSRC			 =     000008000h
DDBLT_KEYSRCOVERRIDE		 =     000010000h
DDBLT_ROP			 =     000020000h
DDBLT_ROTATIONANGLE		 =     000040000h
DDBLT_ZBUFFER			 =     000080000h
DDBLT_ZBUFFERDESTCONSTOVERRIDE	 =     000100000h
DDBLT_ZBUFFERDESTOVERRIDE	 =     000200000h
DDBLT_ZBUFFERSRCCONSTOVERRIDE	 =     000400000h
DDBLT_ZBUFFERSRCOVERRIDE	 =     000800000h
DDBLT_WAIT			 =     001000000h
DDBLT_DEPTHFILL 		 =     002000000h


struct DDBLTFX		      ;(not from example)
	.dwSize 		  dd	   DDBLTFX
	.dwDDFX 		  dd	   ?
	.dwROP			  dd	   ?
	.dwDDROP		  dd	   ?
	.dwRotationAngle	  dd	   ?
	.dwZBufferOpCode	  dd	   ?
	.dwZBufferLow		  dd	   ?
	.dwZBufferHigh		  dd	   ?
	.dwZBufferBaseDest	  dd	   ?
	.dwZDestConstBitDepth	  dd	   ?
  label .dwZDestConst		  dword
	.lpDDSZBufferDest	  dd	   ?
	.dwZSrcConstBitDepth	  dd	   ?
  label .dwZSrcConst		  dword
	.lpDDSZBufferSrc	  dd	   ?
	.dwAlphaEdgeBlendBitDepth dd	   ?
	.dwAlphaEdgeBlend	  dd	   ?
	.dwReserved		  dd	   ?
	.dwAlphaDestConstBitDepth dd	   ?
  label .dwAlphaDestConst	  dword
	.lpDDSAlphaDest 	  dd	   ?
	.dwAlphaSrcConstBitDepth  dd	   ?
  label .dwAlphaSrcConst	  dword
	.lpDDSAlphaSrc		  dd	   ?
  label .dwFillColor		  dword
  label .dwFillDepth		  dword
  label .dwFillPixel		  dword
	.lpDDSPattern		  dd	   ?
	.ddckDestColorkey	  DDCOLORKEY
	.ddckSrcColorkey	  DDCOLORKEY
ends

  DDSCAPS_RESERVED1	      = 00000001h ;{ DDSCAPS_3D }
  DDSCAPS_ALPHA 	      = 00000002h
  DDSCAPS_BACKBUFFER	      = 00000004h
  DDSCAPS_COMPLEX	      = 00000008h
  DDSCAPS_FLIP		      = 00000010h
  DDSCAPS_FRONTBUFFER	      = 00000020h
  DDSCAPS_OFFSCREENPLAIN      = 00000040h
  DDSCAPS_OVERLAY	      = 00000080h
  DDSCAPS_PALETTE	      = 00000100h
  DDSCAPS_PRIMARYSURFACE      = 00000200h
  DDSCAPS_RESERVED3	      = 00000400h ;{ DDSCAPS_PRIMARYSURFACELEFT }
  DDSCAPS_SYSTEMMEMORY	      = 00000800h
  DDSCAPS_TEXTURE	      = 00001000h
  DDSCAPS_3DDEVICE	      = 00002000h
  DDSCAPS_VIDEOMEMORY	      = 00004000h
  DDSCAPS_VISIBLE	      = 00008000h
  DDSCAPS_WRITEONLY	      = 00010000h
  DDSCAPS_ZBUFFER	      = 00020000h
  DDSCAPS_OWNDC 	      = 00040000h
  DDSCAPS_LIVEVIDEO	      = 00080000h
  DDSCAPS_HWCODEC	      = 00100000h
  DDSCAPS_MODEX 	      = 00200000h
  DDSCAPS_MIPMAP	      = 00400000h
  DDSCAPS_RESERVED2	      = 00800000h
  DDSCAPS_ALLOCONLOAD	      = 04000000h
  DDSCAPS_VIDEOPORT	      = 08000000h
  DDSCAPS_LOCALVIDMEM	      = 10000000h
  DDSCAPS_NONLOCALVIDMEM      = 20000000h
  DDSCAPS_STANDARDVGAMODE     = 40000000h
  DDSCAPS_OPTIMIZED	      = 80000000h

;{ DirectDrawSurface Capability Flags 2 }

  DDSCAPS2_HARDWAREDEINTERLACE = 00000002h
  DDSCAPS2_HINTDYNAMIC	       = 00000004h
  DDSCAPS2_HINTSTATIC	       = 00000008h
  DDSCAPS2_TEXTUREMANAGE       = 00000010h
  DDSCAPS2_RESERVED1	       = 00000020h
  DDSCAPS2_RESERVED2	       = 00000040h
  DDSCAPS2_OPAQUE	       = 00000080h
  DDSCAPS2_HINTANTIALIASING    = 00000100h
  DDSCAPS2_CUBEMAP	       = 00000200h
  DDSCAPS2_CUBEMAP_POSITIVEX   = 00000400h
  DDSCAPS2_CUBEMAP_NEGATIVEX   = 00000800h
  DDSCAPS2_CUBEMAP_POSITIVEY   = 00001000h
  DDSCAPS2_CUBEMAP_NEGATIVEY   = 00002000h
  DDSCAPS2_CUBEMAP_POSITIVEZ   = 00004000h
  DDSCAPS2_CUBEMAP_NEGATIVEZ   = 00008000h

  DDSCAPS2_CUBEMAP_ALLFACES    = DDSCAPS2_CUBEMAP_POSITIVEX+DDSCAPS2_CUBEMAP_NEGATIVEX+\
    DDSCAPS2_CUBEMAP_POSITIVEY+DDSCAPS2_CUBEMAP_NEGATIVEY+\
    DDSCAPS2_CUBEMAP_POSITIVEZ+DDSCAPS2_CUBEMAP_NEGATIVEZ

  DDSCAPS2_MIPMAPSUBLEVEL      = 00010000h
  DDSCAPS2_D3DTEXTUREMANAGE    = 00020000h
  DDSCAPS2_DONOTPERSIST        = 00040000h
  DDSCAPS2_STEREOSURFACELEFT   = 00080000h

  DDENUMRET_CANCEL = 0
  DDENUMRET_OK	   = 1






