;============================================================
DoAT10JUMPMainEmulInit:
;============================================================
push ebp
push ebx

LOCALRELEASE [CAnimal_JUMP_Info_BUF]
mov [CAnimal_JUMP_Info_BUF],0

cmp [UseDisableActJumpNew],0
    jnz NoJUMPCodeInit
cmp [CAnimal_BUF],0
    jz NoJUMPCodeInit
cmp [CAnimal_BUF_SIZE],0
    jz NoJUMPCodeInit
cmp [CAnimal_Names_INDEX],0
    jz NoJUMPCodeInit
cmp [CAnimal_Names_BUF],0
    jz NoJUMPCodeInit
cmp [CAnimal_Names_BUF_SIZE],0
    jz NoJUMPCodeInit

	mov eax,[CAnimal_BUF_SIZE]
	lea eax,[eax+eax*4]		 ;4*5 bytes per instance for new buffer

invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	     jz DoAT10JUMPMainEmulInit
	mov [CAnimal_JUMP_Info_BUF],eax

	mov esi,[LEVELNAME_OBJ] 	 ;SCN level name
	mov edi,MapsDirBuffer
	add edi,[MapsPathSize]
	mov DWORD [edi],'JMP\'		 ;'JMP\' folder for jump data
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'	;modify extension

invoke GetPrivateProfileString,STRING_GENERAL,STRING_PUSH,Push_INIdef,Push_default,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_JUMPANGLE,JumpAngle_INIdef,JumpAngle_default,50,MapsDirBuffer
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_JUMPTENDANCY,[JumpTendancy_INIdef],MapsDirBuffer
	mov [JumpTendancy_default],eax
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_REPEATPERIOD,[RepeatPeriod_INIdef],MapsDirBuffer
	mov [RepeatPeriod_default],eax

	mov ebp,[CAnimal_JUMP_Info_BUF]
	mov edi,[CAnimal_Names_INDEX]
	xor ebx,ebx

RetrieveJumpValuesLoop:
	mov esi,[edi+ebx]
	add esi,[CAnimal_Names_BUF]		;esi=pointer to instance/section name

invoke GetPrivateProfileFloat,esi,STRING_PUSH,Push_default,MapsDirBuffer
	mov [ebp+jump_info.Push],eax
invoke GetPrivateProfileFloat,esi,STRING_JUMPANGLE,JumpAngle_default,MapsDirBuffer
	push eax
	fld DWORD [esp]
	fmul [pidiv180] 		;convert angle to radians
	fstp [ebp+jump_info.JumpAngle]
	add esp,4
invoke GetPrivateProfileInt,esi,STRING_JUMPTENDANCY,[JumpTendancy_default],MapsDirBuffer
	mov [ebp+jump_info.JumpTendancy],eax
invoke GetPrivateProfileInt,esi,STRING_REPEATPERIOD,[RepeatPeriod_default],MapsDirBuffer
	mov [ebp+jump_info.RepeatPeriod],eax
	mov [ebp+jump_info.LastTickCount],0

	add ebp,4*5				;jump_info struc size
	add ebx,4
	cmp ebx,[CAnimal_BUF_SIZE]
	    jb RetrieveJumpValuesLoop

mov ecx,[MapsPathSize]
mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
NoJUMPCodeInit:
pop ebx
pop ebp
ret

;============================================================
ACTJUMPNEW_MAIN:	;ecx=ActBite object (dino-specific)
;============================================================
;AT10 object (64 bytes, also add 16 unknown bytes for 'safety'):
;[AT10+00h]      = VTable
;[AT10+00h]      = n/a (set to 0)
;BYTE [AT10+14h] = "Frozen" bool
;[AT10+18h]      = "Target" object
;BYTE [AT10+1Ch] = "Impulse" bool
;[AT10+38h]      = "Push" float
;[AT10+3Ch]      = "Emitter" object
;Note: the Emitter object here uses a CAnimal-type VTable. Only
;its standard methods are used (for all objects), so it will always work
;even though the Emitter is not of CAnimal type class.

push ebp
mov ebp,esp
sub esp,16
push edi
push esi
push ebx
push ecx

	call RANDOMIZE_RANDOM_PROC
	mov ecx,[esp]

	mov edx,[CAnimal_BUF]
	test edx,edx
	     jz no_dinojump_code
	mov ebx,[CAnimal_BUF_SIZE]
	test ebx,ebx
	     jz no_dinojump_code
	add ebx,edx

	FindDinoForActBiteInstanceLoop2:
	mov esi,[edx]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop2
	add edx,4
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop2
	    jmp no_dinojump_code
END_FindDinoForActBiteInstanceLoop2:

	sub edx,[CAnimal_BUF]
	mov ebx,[CAnimal_JUMP_Info_BUF]

	;esi = dino object, edx = dino info CAnimal buffer offset

	lea edx,[edx+edx*4]	       ;get buffer offset for jump info buffer (*4*5)
	test ebx,ebx
	     jz no_dinojump_code
	add ebx,edx

	;ebx = dino's jump info

;ensure interval has elapsed (RepeatPeriod)
	invoke GetTickCount
	sub eax,[ebx+jump_info.LastTickCount]
	cmp eax,[ebx+jump_info.RepeatPeriod]
	    jb no_dinojump_code
	add [ebx+jump_info.LastTickCount],eax	;store last tick count

;determine if dino is to jump or not (randomly based on JumpTendancy value)

	stdcall GetRandomNumber,100
	cmp eax,[ebx+jump_info.JumpTendancy]
	    ja no_dinojump_code

	mov edi,AT10_EMITTER_SIM_OBJECT
	mov [edi+4],DWORD 0

	lea ecx,[ebx+jump_info.JumpAngle]	;(stored in radians)
	lea edx,[ebp-16]			;local quat
	call ToLocalQuat_AxisX

	lea eax,[esi+3Ch]			;source quat (to rotate)
	lea ecx,[ebp-16]			;local quat (rotation)
	lea edx,[edi+3Ch]			;result
	call QuaternionMul

	mov eax,[esi+30h]
	mov [edi+30h],eax			;Xposition (Emitter)
	mov eax,[esi+34h]
	mov [edi+34h],eax			;Yposition (Emitter)

	fld DWORD [esi+38h]
	fsub [float_100]
	fstp DWORD [edi+38h]			;Zposition (Emitter)

	mov ecx,AT10_SIM_OBJECT
	mov eax,[ebx+jump_info.Push]
	mov [ecx+04h],DWORD 0
	mov [ecx+18h],esi			;Target
	or BYTE [ecx+1Ch],1			;Impulse
	mov [ecx+38h],eax			;Push (force)
	mov [ecx+3Ch],edi			;Emitter object
	mov eax,[ecx]
	call DWORD [eax+8]			;AT10 MAIN PROC

no_dinojump_code:
pop ecx
pop ebx
pop esi
pop edi
mov esp,ebp
pop ebp
ret

