;compile using FASM (see "SOURCE_README.txt" for last version used)

RECCMPOPTS_VERSION	   equ	   '1.0'

format PE GUI 4.0
entry START
stack 20000h		;required: GetOpenFileName may crash under certain circumstances if less
			;(witnessed with WinRAR menu options, when right-clicking on an EXE file)

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this
include 'constants.inc'
include 'strucs.inc'
include 'macros.inc'

;=================================================================
section '.code' code readable executable
;=================================================================
;edi = messagebox text
START:
push ebp
push ebx
push esi
push edi

invoke LoadLibrary,AVI_DLL_Name
       test eax,eax
       mov edi,error5
	    jz RECCMPOPTSERROR1

       mov [AVI_DLL_Handle],eax
       mov edi,error6
       mov esi,AVI_Function_Table

       AVI_Function_Table_LOOP:
       invoke GetProcAddress,[AVI_DLL_Handle],[esi+4]
	      test eax,eax
		   jz RECCMPOPTSERROR2
       AVIProc_Valid:
       mov [esi],eax
       add esi,8
       cmp esi,AVI_Function_Table_END
	   jb AVI_Function_Table_LOOP

	invoke AVIFileInit
	;mov [avi_create_info.dwSuggestedBufferSize],0

	mov [avi_create_info.fccType],'vids'			;FOURCC code
	;mov [avi_create_info.fccHandler],0
	mov [avi_create_info.dwQuality],1
	mov [avi_create_info.dwScale],1
	mov [avi_create_info.dwRate],20
	mov [avi_create_info.rcFrame.right],320
	mov [avi_create_info.rcFrame.bottom],240		;values are unimportant

	invoke DeleteFile,tempsaveoptionsavi_name

;open temporary AVI file (for save options only)
	invoke AVIFileOpen,avifile_handle,tempsaveoptionsavi_name,OF_CREATE+OF_READWRITE,0
	       test eax,eax
	       mov edi,error3
		    jnz RECCMPOPTSERROR3

;create temporary uncompressed stream
	invoke AVIFileCreateStream,[avifile_handle],avistream_handle_orig,avi_create_info
	       test eax,eax
	       mov edi,error4
		    jnz RECCMPOPTSERROR4

;show Compression Options dialog
       invoke GetDesktopWindow
	       mov esi,eax
       invoke SetForegroundWindow,esi
       invoke UpdateWindow,esi

       invoke AVISaveOptions,esi,ICMF_CHOOSE_DATARATE,1,\
			avistream_handle_orig,avi_compress_opts_addr
	       cmp eax,TRUE
	       mov edi,error2
		   jnz RECCMPOPTSERROR5


	invoke CreateFile,reccmpoptsdata_name,GENERIC_WRITE,0,0,CREATE_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	       cmp eax,-1
	       mov edi,error1
		   jz RECCMPOPTSERROR6
	       mov [reccmpoptsdata_handle],eax

	invoke SetFilePointer,eax,0,0,FILE_BEGIN
	       cmp eax,-1
		   jz RECCMPOPTSERROR6

	invoke WriteFile,[reccmpoptsdata_handle],avi_compress_opts,11*4,numbyteswritten,0
	       test eax,eax
		   jz RECCMPOPTSERROR6

	mov edx,[avi_compress_opts.lpFormat]
	test edx,edx
	     jz NoDataFormatStruct
	mov ecx,[avi_compress_opts.cbFormat]
	test ecx,ecx
	     jz NoDataFormatStruct
	invoke WriteFile,[reccmpoptsdata_handle],edx,ecx,numbyteswritten,0
	       test eax,eax
		   jz RECCMPOPTSERROR6
	NoDataFormatStruct:

	mov edx,[avi_compress_opts.lpParms]
	test edx,edx
	     jz NoCompParmsStruct
	mov ecx,[avi_compress_opts.cbParms]
	test ecx,ecx
	     jz NoCompParmsStruct
	invoke WriteFile,[reccmpoptsdata_handle],edx,ecx,numbyteswritten,0
	       test eax,eax
		   jz RECCMPOPTSERROR6
	NoCompParmsStruct:

	mov edi,success1
;============================================================
RECCMPOPTSERROR6:
	CLOSEHANDLE [reccmpoptsdata_handle]
RECCMPOPTSERROR5:
	invoke AVISaveOptionsFree,1,avi_compress_opts_addr
	RCALL AVIStreamRelease,[avistream_handle_orig] ;-> WILL CAUSE ERROR IF INCLUDED (???)
RECCMPOPTSERROR4:
	RCALL AVIFileRelease,[avifile_handle]
	invoke DeleteFile,tempsaveoptionsavi_name
RECCMPOPTSERROR3:
	invoke AVIFileExit
RECCMPOPTSERROR2:
	RCALL FreeLibrary,[AVI_DLL_Handle]
RECCMPOPTSERROR1:

	invoke MessageBox,0,edi,msgbox_caption,0

pop edi
pop esi
pop ebx
pop ebp
invoke ExitProcess,0

;=================================================================
section '.data' data readable writeable
;=================================================================
include 'aviimport.inc'
reccmpoptsdata_name	db	"reccmpopts.dat",0
reccmpoptsdata_handle	dd	0
numbyteswritten 	dd	0

msgbox_caption	db	"REC Compression Options",0
error1		db	"Error: fault creating/writing recmpops.dat data file.",0
error2		db	"Error: Video recording options modification cancelled.",0
error3		db	"Error: could not create temporary AVI file",0
error4		db	"Error: could not create temporary AVI stream",0
error5		db	"Error: could not load AVIFIL32.DLL",0
error6		db	"Error: could not obtain required AVIFIL32.DLL functions",0
error7		db	"Error:",0
success1	db	"New recording/compression options successfully saved.",0

tempsaveoptionsavi_name db	"reccmpoptstempfile.avi",0

avistream_handle_orig	dd	0
avifile_handle		dd	0

avi_create_info 	AVISTREAMINFO

avi_compress_opts_addr	dd	avi_compress_opts
avi_compress_opts	AVICOMPRESSOPTIONS

;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,"KERNEL32.DLL",\
	  user32,"USER32.DLL"

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 DeleteFile,'DeleteFileA',\
	 ExitProcess,"ExitProcess",\
	 FindClose,"FindClose",\
	 FindFirstFile,"FindFirstFileA",\
	 FreeLibrary,"FreeLibrary",\
	 GetCurrentProcessId,"GetCurrentProcessId",\
	 GetFileSize,"GetFileSize",\
	 GetLastError,"GetLastError",\
	 GetProcAddress,"GetProcAddress",\
	 LoadLibrary,"LoadLibraryA",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 LocalReAlloc,"LocalReAlloc",\
	 LocalSize,"LocalSize",\
	 ReadFile,"ReadFile",\
	 SetFileAttributes,"SetFileAttributesA",\
	 SetFilePointer,"SetFilePointer",\
	 WriteFile,"WriteFile"

  import user32,\
	 DestroyWindow,"DestroyWindow",\
	 CloseWindow,"CloseWindow",\
	 GetActiveWindow,"GetActiveWindow",\
	 GetDesktopWindow,"GetDesktopWindow",\
	 MessageBox,"MessageBoxA",\
	 SetFocus,"SetFocus",\
	 SetForegroundWindow,"SetForegroundWindow",\
	 ShowWindow,"ShowWindow",\
	 UpdateWindow,"UpdateWindow",\
	 wsprintf,"wsprintfA"

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_VERSION,versions

	resource versions,\
	   1,LANG_NEUTRAL,version_info

	version version_info,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','ATX Trespasser REC compression options',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',RECCMPOPTS_VERSION,\
	  'ProductVersion',RECCMPOPTS_VERSION,\
	  'OriginalFilename','RECCMPOPTS.EXE'